// SPDX-License-Identifier: Apache-2.0
import { createMock } from "@golevelup/ts-jest";
import { EvmAddressPropsFixture } from "../../../../../../../__tests__/fixtures/shared/DataFixture";
import EvmAddress from "../../../../../../domain/context/contract/EvmAddress";
import { Security } from "../../../../../../domain/context/security/Security";
import { SecurityPropsFixture } from "../../../../../../../__tests__/fixtures/shared/SecurityFixture";
import { IsInternalKycActivatedQueryResponse } from "./IsInternalKycActivatedQuery";
import { IsInternalKycActivatedQueryHandler } from "./IsInternalKycActivatedQueryHandler";
import { IsInternalKycActivatedQueryFixture } from "../../../../../../../__tests__/fixtures/kyc/KycFixture";
describe("IsInternalKycActivatedQueryHandler", () => {
    let handler;
    let query;
    const securityServiceMock = createMock();
    const queryAdapterServiceMock = createMock();
    const contractServiceMock = createMock();
    const evmAddress = new EvmAddress(EvmAddressPropsFixture.create().value);
    const security = new Security(SecurityPropsFixture.create());
    beforeEach(() => {
        handler = new IsInternalKycActivatedQueryHandler(securityServiceMock, contractServiceMock, queryAdapterServiceMock);
        query = IsInternalKycActivatedQueryFixture.create();
    });
    afterEach(() => {
        jest.resetAllMocks();
    });
    describe("execute", () => {
        it("should successfully check if internal kyc is activated", async () => {
            securityServiceMock.get.mockResolvedValueOnce(security);
            contractServiceMock.getContractEvmAddress.mockResolvedValueOnce(evmAddress);
            queryAdapterServiceMock.isInternalKycActivated.mockResolvedValue(true);
            const result = await handler.execute(query);
            expect(result).toBeInstanceOf(IsInternalKycActivatedQueryResponse);
            expect(result.payload).toBe(true);
            expect(contractServiceMock.getContractEvmAddress).toHaveBeenCalledTimes(1);
            expect(securityServiceMock.get).toHaveBeenCalledTimes(1);
            expect(queryAdapterServiceMock.isInternalKycActivated).toHaveBeenCalledTimes(1);
            expect(securityServiceMock.get).toHaveBeenCalledWith(query.securityId);
            expect(contractServiceMock.getContractEvmAddress).toHaveBeenCalledWith(query.securityId);
            expect(queryAdapterServiceMock.isInternalKycActivated).toHaveBeenCalledWith(evmAddress);
        });
    });
});
